com.microfocus.awm.model

## Interface ITaurusApplication

- All Superinterfaces:
    org.eclipse.core.runtime.IAdaptable, IResource
  All Known Implementing Classes:
    AbstractTaurusApplication, MasterConfigurationApplication

      public interface ITaurusApplication
      extends IResource

  Main representation of an AWM model at runtime.

  Loading an application will parse and activate the AWM model it is referring to. Only one AWM application can be active at a time.

  See Also:
    `AbstractTaurusApplication`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `ITaurusApplication.EModelUpdateStatus` The update status of the application.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `ID_PREFIX` Cache ID prefix.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `addApplicationProperty(IApplicationProperty pApplicationProperty)` Adds an `IApplicationProperty` to the `ITaurusApplication`.
    `void` | `addStaticProperty(java.lang.String pID, java.lang.String pValue)` Deprecated. `addStaticProperty(String, String)` is no longer supported. Use `addApplicationProperty(IApplicationProperty)` instead to get proper support for `IApplicationProperty`s.
    `ITaurusApplication.EModelUpdateStatus` | `checkForModelUpdate(org.eclipse.core.runtime.IProgressMonitor pMon)` Checks whether a new model is available for the application.
    `java.util.Collection<IApplicationProperty>` | `getApplicationProperties()` Returns an copy of the `Collection` of `IApplicationProperty`s.
    `IElementList` | `getChildren(boolean pRefresh, org.eclipse.core.runtime.IProgressMonitor pMonitor)` Deprecated. Use `getChildren(EGetChildrenMode,IProgressMonitor)` instead.
    `GetChildrenResult` | `getChildren(EGetChildrenMode pType, org.eclipse.core.runtime.IProgressMonitor pMonitor)` Fetch the children of the root container type sorted by the container type's sort criterion from the remote system.
    `java.lang.String` | `getCustomAttribute(java.lang.String pName)` Gets the value of a custom system attribute by the given name.
    `java.util.Map<java.lang.String,java.lang.String>` | `getCustomAttributes()` Gets all custom attributes that have been set for the application.
    `TAURUSConfiguration` | `getModel()` Gets the AWM model.
    `java.util.Map<java.lang.String,java.lang.String>` | `getStaticProperties()` Deprecated. `getStaticProperties()` is no longer supported. Used `getApplicationProperties()` instead to get a proper support for `IApplicationProperty`s.
    `ITaurusSystem` | `getTaurusSystem()` Get this AWM application's system.
    `boolean` | `hasChildren()` Checks if the AWM application has children.
    `void` | `loadApplication(boolean pReload, org.eclipse.core.runtime.IProgressMonitor pMon)` Load this AWM application as active AWM application; load the corresponding configuration data set and all saved AWM data.
    `boolean` | `removeApplicationProperty(IApplicationProperty pApplicationProperty)` Removes an `IApplicationProperty` from the `ITaurusApplication`
    `void` | `removeChildren()` Recursively remove the children of this AWM application.
    `void` | `unloadApplication()` Unload the configuration data set and the AWM application data in the local workspace.

    - ### Methods inherited from interface com.microfocus.awm.model.IResource

      `addChildResource, addPropertyValue, addResourceChild, delete, getAllPropertyValues, getChildrenResources, getID, getName, getParentResource, getPropertyValue, getPropertyValueFromHierarchy, getResourceChildren, removeResourceChild, setName, setPropertyValues`

    - ### Methods inherited from interface org.eclipse.core.runtime.IAdaptable

      `getAdapter`

- - ### Field Detail

    - #### ID_PREFIX

          static final java.lang.String ID_PREFIX

      Cache ID prefix.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### getCustomAttribute

          java.lang.String getCustomAttribute(java.lang.String pName)

      Gets the value of a custom system attribute by the given name.
      Parameters:
        `pName` - the name of the desired attribute
      Returns:
        the custom attribute value or `null` if no attribute with the given name was set
      See Also:
        `getCustomAttributes()`

    - #### getCustomAttributes

          java.util.Map<java.lang.String,java.lang.String> getCustomAttributes()

      Gets all custom attributes that have been set for the application. Custom attributes will be cached by AWM.
      Returns:
        a list of custom attributes (key/value pairs)

    - #### getTaurusSystem

          ITaurusSystem getTaurusSystem()

      Get this AWM application's system.
      Returns:
        AWM application's system

    - #### getChildren

          @Deprecated
          IElementList getChildren(boolean pRefresh,
                                                org.eclipse.core.runtime.IProgressMonitor pMonitor)
                                         throws TaurusException

      Deprecated. Use `getChildren(EGetChildrenMode,IProgressMonitor)` instead.
      Fetch the children of the root container type sorted by the container type's sort criterion from the remote system.
      Parameters:
        `pRefresh` - whether to refresh the application children (or use the cache)
        `pMonitor` - progress monitor
      Returns:
        set of children container's of the root container type
      Throws:
        `TaurusException` - if getting the children fails

    - #### getChildren

          GetChildrenResult getChildren(EGetChildrenMode pType,
                                        org.eclipse.core.runtime.IProgressMonitor pMonitor)
                                 throws TaurusException

      Fetch the children of the root container type sorted by the container type's sort criterion from the remote system.
      Parameters:
        `pType` - how to refresh the application children (or use the cache)
        `pMonitor` - progress monitor
      Returns:
        the `GetChildrenResult` of children's fetching
      Throws:
        `TaurusException` - if getting the children fails

    - #### hasChildren

          boolean hasChildren()

      Checks if the AWM application has children.
      Returns:
        `true` if the application has children, otherwise `false`

    - #### removeChildren

          void removeChildren()
                       throws TaurusCoreException

      Recursively remove the children of this AWM application.
      Throws:
        `TaurusCoreException` - if removing the children fails

    - #### loadApplication

          void loadApplication(boolean pReload,
                               org.eclipse.core.runtime.IProgressMonitor pMon)
                        throws TaurusCoreException

      Load this AWM application as active AWM application; load the corresponding configuration data set and all saved AWM data.
      Parameters:
        `pReload` - reloads the configuration file of this application if set `true`. This won't effect the first load of the configuration.
        `pMon` - progress monitor
      Throws:
        `TaurusCoreException` - if the application could not be loaded

    - #### unloadApplication

          void unloadApplication()
                          throws TaurusCoreException

      Unload the configuration data set and the AWM application data in the local workspace.
      Throws:
        `TaurusCoreException` - if the application could not be unloaded

    - #### getStaticProperties

          @Deprecated
          java.util.Map<java.lang.String,java.lang.String> getStaticProperties()

      Deprecated. `getStaticProperties()` is no longer supported. Used `getApplicationProperties()` instead to get a proper support for `IApplicationProperty`s.
      Returns the Property IDs and values, which were set in the Master Configuration File for this Application.
      Returns:
        a map, containing Property IDs (Entry Key) and values (Entry Value) of all static properties of the application

    - #### getApplicationProperties

          java.util.Collection<IApplicationProperty> getApplicationProperties()

      Returns an copy of the `Collection` of `IApplicationProperty`s. Changing the returned `Collection` won´t affect the application properties of the `ITaurusApplication`.

      The `Collection` of `IApplicationProperty`s gets filled once the application was loaded.

      To add or remove `IApplicationProperty`s use the methods `addApplicationProperty(IApplicationProperty)` or `removeApplicationProperty(IApplicationProperty)`.

      Returns:
        the `IApplicationProperty`s of the `ITaurusApplication`

    - #### removeApplicationProperty

          boolean removeApplicationProperty(IApplicationProperty pApplicationProperty)

      Removes an `IApplicationProperty` from the `ITaurusApplication`
      Parameters:
        `pApplicationProperty` - the `IApplicationProperty` which should be removed.
      Returns:
        whether the `IApplicationProperty` was removed successfully.

    - #### addApplicationProperty

          boolean addApplicationProperty(IApplicationProperty pApplicationProperty)

      Adds an `IApplicationProperty` to the `ITaurusApplication`.
      Parameters:
        `pApplicationProperty` - the `IApplicationProperty` which should be added.
      Returns:
        whether the `IApplicationProperty` was added successfully.

    - #### addStaticProperty

          @Deprecated
          void addStaticProperty(java.lang.String pID,
                                              java.lang.String pValue)

      Deprecated. `addStaticProperty(String, String)` is no longer supported. Use `addApplicationProperty(IApplicationProperty)` instead to get proper support for `IApplicationProperty`s.
      Adds a Property ID and it's new static value to the application.
      Parameters:
        `pID` - The ID of the Property
        `pValue` - The new static value for the given Property ID

    - #### checkForModelUpdate

          ITaurusApplication.EModelUpdateStatus checkForModelUpdate(org.eclipse.core.runtime.IProgressMonitor pMon)
                                                             throws TaurusCoreException

      Checks whether a new model is available for the application. Will be called only once per session and application. Usually the application update status is set/refreshed by this method.
      Parameters:
        `pMon` - a progress monitor
      Returns:
        the model update status
      Throws:
        `TaurusCoreException` - if checking for a model update fails

    - #### getModel

          TAURUSConfiguration getModel()

      Gets the AWM model. This should be a simple getter, since AWM can call this method quite frequently. Usually the model is loaded within `loadApplication(boolean, IProgressMonitor)`.
      Returns:
        the `TAURUSConfiguration` of the application or `null` if it hasn't been loaded before.

Copyright © 2015 Micro Focus GmbH. All rights reserved.